unit unit_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, StrUtils, IniFiles;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    GoButton: TButton;
    Memo2: TMemo;
    CloseButton: TButton;
    Panel2: TPanel;
    Label1: TLabel;
    Operator1TypeEditBox: TComboBox;
    Operator2TypeEditBox: TComboBox;
    Label2: TLabel;
    ExpressionTypeEditBox: TComboBox;
    Label3: TLabel;
    CancelButton: TButton;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Operator1IncrementUp: TCheckBox;
    Operator2IncrementUp: TCheckBox;
    Label9: TLabel;
    Label10: TLabel;
    Operator1StartFromEditBox: TComboBox;
    Operator2StartFromEditBox: TComboBox;
    Operator1EndAtEditBox: TComboBox;
    Operator2EndAtEditBox: TComboBox;
    CompilerBox: TGroupBox;
    Amicus18RadioButton: TRadioButton;
    ProtonRadioButton: TRadioButton;
    DeviceGroupBox: TGroupBox;
    Core14RadioButton: TRadioButton;
    Core14eRadioButton: TRadioButton;
    Core16RadioButton: TRadioButton;
    Label4: TLabel;
    AssignmentTypeEditBox: TComboBox;
    Operator1IncrementsEditBox: TComboBox;
    Operator2IncrementsEditBox: TComboBox;
    DifferentBanks: TCheckBox;
    procedure GoButtonClick(Sender: TObject);
    procedure CloseButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure Amicus18RadioButtonClick(Sender: TObject);
    procedure ProtonRadioButtonClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Core14RadioButtonClick(Sender: TObject);
    procedure Core14eRadioButtonClick(Sender: TObject);
    procedure Core16RadioButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure PrintCode(pText: String);
    procedure PrintMessage(pText: String);
    procedure GetOperatorTypes();
    procedure PlaceVariableDeclarations(pOperatorType1: Int64; pOperatorType2: Int64);
    procedure PlaceExpression(pOperatorValue1: Int64; pOperatorValue2: Int64);
  end;

var
    Form1: TForm1;
    DLIniFile: TIniFile;
    tCloseButtonPressed: Boolean;
    tCancelButtonPressed: Boolean;
    Global_OperatorName1: String;
    Global_OperatorName2: String;
    Global_AssignmentName: String;
    ExpressionType: String;
    Global_OperatorType1: Integer;
    Global_OperatorType2: Integer;
    Global_AssignmentType: Integer;

const
    cType_Byte = 1;
    cType_Word = 2;
    cType_Dword = 3;
    cType_Float = 4;
    cType_SByte = 5;
    cType_SWord = 6;
    cType_SDword = 7;
    cType_Constant = 8;
    cType_SignedConstant = 9;
    cType_FloatConstant = 10;

implementation

{$R *.dfm}
//-----------------------------------------------------------------------------------------
// Close Query event
//
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
//
// Write the current settings to an ini file
//
    DLIniFile.WriteString('Options','Operator1Type',Operator1TypeEditBox.Text);
    DLIniFile.WriteString('Options','Operator2Type',Operator2TypeEditBox.Text);
    DLIniFile.WriteString('Options','AssignmentType',AssignmentTypeEditBox.Text);
    DLIniFile.WriteString('Options','ExpressionType',ExpressionTypeEditBox.Text);
    DLIniFile.WriteBool('Options','DifferentBanks',DifferentBanks.Checked);

    DLIniFile.WriteString('Options','Operator1Start',Operator1StartFromEditBox.Text);
    DLIniFile.WriteString('Options','Operator2Start',Operator2StartFromEditBox.Text);
    DLIniFile.WriteString('Options','Operator1End',Operator1EndAtEditBox.Text);
    DLIniFile.WriteString('Options','Operator2End',Operator2EndAtEditBox.Text);
    DLIniFile.WriteString('Options','Operator1Inc',Operator1IncrementsEditBox.Text);
    DLIniFile.WriteString('Options','Operator2Inc',Operator2IncrementsEditBox.Text);
    DLIniFile.WriteBool('Options','Operator1Up',Operator1IncrementUp.Checked);
    DLIniFile.WriteBool('Options','Operator2Up',Operator2IncrementUp.Checked);
    //
    // Compiler type
    //
    DLIniFile.WriteBool('Options','Amicus18',Amicus18RadioButton.Checked);
    DLIniFile.WriteBool('Options','Proton',ProtonRadioButton.Checked);
    //
    // Device type
    //
    DLIniFile.WriteBool('Options','Core14',Core14RadioButton.Checked);
    DLIniFile.WriteBool('Options','Core14e',Core14eRadioButton.Checked);
    DLIniFile.WriteBool('Options','Core16',Core16RadioButton.Checked);
end;
//-----------------------------------------------------------------------------------------
// Close button pressed
//
procedure TForm1.CloseButtonClick(Sender: TObject);
begin
    tCloseButtonPressed := True;
    Close();
end;
//-----------------------------------------------------------------------------------------
// Cancel Button Pressed
//
procedure TForm1.CancelButtonClick(Sender: TObject);
begin
    tCancelButtonPressed := True;
end;
//-----------------------------------------------------------------------------------------
// Form Create event
procedure TForm1.FormCreate(Sender: TObject);
begin
    tCloseButtonPressed := False;
    tCancelButtonPressed := False;
end;
//-----------------------------------------------------------------------------------------
// Form Active event
//
procedure TForm1.FormActivate(Sender: TObject);
begin
    OnActivate := Nil;

    //DeviceGroupBox.Enabled := False;
    //Core14RadioButton.Enabled := False;
    //Core14eRadioButton.Enabled := False;
    //Core16RadioButton.Enabled := False;
    //Core24RadioButton.Enabled := False;
end;
//-----------------------------------------------------------------------------------------
// Form Show event
// Read or write the ini file
//
procedure TForm1.FormShow(Sender: TObject);
Var
    CurrentDirectory: String;
begin
    CurrentDirectory := ExtractFileDir(Application.EXEName) + '\';

    If(FileExists(CurrentDirectory + 'Expression_Gen.ini')) Then
    	Begin
            DLIniFile := TIniFile.Create(CurrentDirectory + 'Expression_Gen.ini');

            Operator1TypeEditBox.Text := DLIniFile.ReadString('Options','Operator1Type','sbyte');
            Operator2TypeEditBox.Text := DLIniFile.ReadString('Options','Operator2Type','sbyte');
            AssignmentTypeEditBox.Text := DLIniFile.ReadString('Options','AssignmentType','sbyte');
            ExpressionTypeEditBox.Text := DLIniFile.ReadString('Options','ExpressionType','+');
            DifferentBanks.Checked := DLIniFile.ReadBool('Options','DifferentBanks',false);

            Operator1StartFromEditBox.Text := DLIniFile.ReadString('Options','Operator1Start','-128');
            Operator2StartFromEditBox.Text := DLIniFile.ReadString('Options','Operator2Start','-128');
            Operator1EndAtEditBox.Text := DLIniFile.ReadString('Options','Operator1End','127');
            Operator2EndAtEditBox.Text := DLIniFile.ReadString('Options','Operator2End','127');
            Operator1IncrementsEditBox.Text := DLIniFile.ReadString('Options','Operator1Inc','1');
            Operator2IncrementsEditBox.Text := DLIniFile.ReadString('Options','Operator2Inc','1');
            Operator1IncrementUp.Checked := DLIniFile.ReadBool('Options','Operator1Up',false);
            Operator2IncrementUp.Checked := DLIniFile.ReadBool('Options','Operator2Up',false);
            //
            // Compiler type
            //
            Amicus18RadioButton.Checked := DLIniFile.ReadBool('Options','Amicus18',true);
            ProtonRadioButton.Checked := DLIniFile.ReadBool('Options','Proton',false);
            //
            // Device type
            //
            Core14RadioButton.Checked := DLIniFile.ReadBool('Options','Core14',true);
            Core14eRadioButton.Checked := DLIniFile.ReadBool('Options','Core14e',false);
            Core16RadioButton.Checked := DLIniFile.ReadBool('Options','Core16',false);
        End
    Else
        Begin
            DLIniFile := TIniFile.Create(CurrentDirectory + 'Expression_Gen.ini');  	// ini file doesn't exist
            DLIniFile.WriteString('Options','Operator1Type','sbyte');
            DLIniFile.WriteString('Options','Operator2Type','sbyte');
            DLIniFile.WriteString('Options','AssignmentType','sbyte');
            DLIniFile.WriteString('Options','ExpressionType','+');
            DLIniFile.WriteBool('Options','DifferentBanks',false);

            DLIniFile.WriteString('Options','Operator1Start','-128');
            DLIniFile.WriteString('Options','Operator2Start','-128');
            DLIniFile.WriteString('Options','Operator1End','127');
            DLIniFile.WriteString('Options','Operator2End','127');
            DLIniFile.WriteString('Options','Operator1Inc','1');
            DLIniFile.WriteString('Options','Operator2Inc','1');
            DLIniFile.WriteBool('Options','Operator1Up',false);
            DLIniFile.WriteBool('Options','Operator2Up',false);
            //
            // Compiler type
            //
            DLIniFile.WriteBool('Options','Amicus18',true);
            DLIniFile.WriteBool('Options','Proton',false);
            //
            // Device type
            //
            DLIniFile.WriteBool('Options','Core14',true);
            DLIniFile.WriteBool('Options','Core14e',false);
            DLIniFile.WriteBool('Options','Core16',false);
        End;
end;
//-----------------------------------------------------------------------------------------
// Form Close event
//
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Try
  	DLIniFile.Free;
Except
End;
end;
//-----------------------------------------------------------------------------------------
procedure TForm1.GoButtonClick(Sender: TObject);
var
    Operator1Value: Int64;
    Operator2Value: Int64;
    LoopCount: Integer;
    LoopIncrement: Integer;
    Operator1From, Operator1To: Int64;
    Operator2From, Operator2To: Int64;
    Iterations: Integer;
    Operator1Increments, Operator2Increments: Int64;
    Operator1Span, Operator2Span: Int64;
begin
    tCloseButtonPressed := False;
    tCancelButtonPressed := False;
    Memo1.Lines.BeginUpdate();
    Memo1.Clear();
    Memo1.Lines.EndUpdate();

    Memo2.Lines.BeginUpdate();
    Memo2.Clear();
    Memo2.Lines.EndUpdate();
//
// Get the variable types by examining the edit boxes
//
    GetOperatorTypes();
//
//
//
    ExpressionType := ExpressionTypeEditBox.Text;                       // Get the expression type

    Operator1Increments := StrToInt64(Operator1IncrementsEditBox.Text);
    Operator2Increments := StrToInt64(Operator2IncrementsEditBox.Text);
//
// Convert constants to signed or unsigned depending on the operator
// StrToInt64 is used for unsigned operator values
// While StrToInt is used for signed operator values
//
    If((Global_OperatorType1 = cType_Byte) Or (Global_OperatorType1 = cType_Word) Or (Global_OperatorType1 = cType_Dword) Or (Global_OperatorType1 = cType_Constant)) Then
        begin
            Operator1From := StrToInt64(Operator1StartFromEditBox.Text);
            Operator1To := StrToInt64(Operator1EndAtEditBox.Text);
        end
    Else
        begin
            Operator1From := StrToInt(Operator1StartFromEditBox.Text);
            Operator1To := StrToInt(Operator1EndAtEditBox.Text);
        end;
    If((Global_OperatorType2 = cType_Byte) Or (Global_OperatorType2 = cType_Word) Or (Global_OperatorType2 = cType_Dword) Or (Global_OperatorType2 = cType_SignedConstant)) Then
        begin
            Operator2From := StrToInt64(Operator2StartFromEditBox.Text);
            Operator2To := StrToInt64(Operator2EndAtEditBox.Text);
        end
    Else
        begin
            Operator2From := StrToInt(Operator2StartFromEditBox.Text);
            Operator2To := StrToInt(Operator2EndAtEditBox.Text);
        end;
    Operator1Span := abs(Operator1To) + abs(Operator1From);               // Find the span of operator 1
    Operator2Span := abs(Operator2To) + abs(Operator2From);               // Find the span of operator 2
    //PrintMessage('Operator1Span = ' + IntToStr(Operator1Span));
    //PrintMessage('Operator2Span = ' + IntToStr(Operator2Span));
//
// Place the variable declarations
//
    PlaceVariableDeclarations(Global_OperatorType1, Global_OperatorType2);

    If(Operator1IncrementUp.Checked = True) Then
        Operator1Value := Operator1From
    Else
        Operator1Value := Operator1To;

    If(Operator2IncrementUp.Checked = True) Then
        Operator2Value := Operator2From
    Else
        Operator2Value := Operator2To;

    LoopCount := 0;
        Memo1.Lines.BeginUpdate();
            Repeat
                If((Global_OperatorType1 = cType_Constant) Or (Global_OperatorType1 = cType_SignedConstant)) Then
                    begin
                        Global_OperatorName1 := IntToStr(Operator1Value);
                    end;

                If((Global_OperatorType2 = cType_Constant) Or (Global_OperatorType2 = cType_SignedConstant))Then
                    begin
                        Global_OperatorName2 := IntToStr(Operator2Value);
                    end;

                PlaceExpression(Operator1Value, Operator2Value);
                //
                // First operator
                //
                If(Operator1IncrementUp.Checked = True) Then
                    begin
                        Operator1Value := Operator1Value + Operator1Increments;
                        If(Operator1Value > Operator1To) Then
                            begin
                                Operator1Value := Operator1From;
                            end;
                    end
                Else
                    begin
                        Operator1Value := Operator1Value - Operator1Increments;
                        If(Operator1Value < Operator1From) Then
                            begin
                                Operator1Value := Operator1To;
                            end;
                    end;
                //
                // Second operator
                //
                If(Operator2IncrementUp.Checked = True) Then
                    begin
                        Operator2Value := Operator2Value + Operator2Increments;
                        If(Operator2Value > Operator2To) Then
                            begin
                                Operator2Value := Operator2From;
                            end;
                    end
                Else
                    begin
                        Operator2Value := Operator2Value - Operator2Increments;
                        If(Operator2Value < Operator2From) Then
                            begin
                                Operator2Value := Operator2To;
                            end;
                    end;

                LoopCount := LoopCount + 1;

                If(Operator1Span > Operator2Span) Then
                    begin
                        Iterations := (Operator1To - Operator1From) div Operator1Increments;
                    end
                Else
                    begin
                        Iterations := (Operator2To - Operator2From) div Operator2Increments;
                    end;
                If((tCloseButtonPressed = True) Or (tCancelButtonPressed = True)) Then Break;
            Until LoopCount >= Iterations;
    PrintCode('    Stop');

    Memo1.Lines.EndUpdate();
    If(tCloseButtonPressed = True) Then Exit;
    Memo1.SelectAll();
    Memo1.CopyToClipboard();
    PrintMessage(IntToStr(LoopCount) + ' Expressions');
    PrintMessage('The test program is now in the clipboard');
end;
//-----------------------------------------------------------------------------------------
//
//
procedure TForm1.PlaceExpression(pOperatorValue1: Int64; pOperatorValue2: Int64);
Var
    AssignmentValue: Int64;
    Operator1HexString: String;
    Operator2HexString: String;
    AssignmentHexString: String;
    ModifierHexSizeString: String;
begin
    If((pOperatorValue1 = 0) Or (pOperatorValue2 = 0)) Then exit;

    If((Global_OperatorType1 <> cType_Constant) And (Global_OperatorType1 <> cType_SignedConstant))Then
        begin
            PrintCode('    ' + Global_OperatorName1 + ' = ' + IntToStr(pOperatorValue1));
        end;

    If((Global_OperatorType2 <> cType_Constant) And (Global_OperatorType2 <> cType_SignedConstant))Then
        begin
            PrintCode('    ' + Global_OperatorName2 + ' = ' + IntToStr(pOperatorValue2));
        end;

    PrintCode('    ' + Global_AssignmentName + ' = ' + Global_OperatorName1 + ' ' + ExpressionType + ' ' + Global_OperatorName2);

    if(ExpressionType = '+') Then
        begin
            AssignmentValue := pOperatorValue1 + pOperatorValue2;
        end;

    if(ExpressionType = '-') Then
        begin
            AssignmentValue := pOperatorValue1 - pOperatorValue2;
        end;

    if(ExpressionType = '*') Then
        begin
            AssignmentValue := pOperatorValue1 * pOperatorValue2;
        end;

    if(ExpressionType = '/') Then
        begin
            AssignmentValue := pOperatorValue1 div pOperatorValue2;
        end;
//
// Find the length of the hex value to display
//

    If((pOperatorValue1 >= -128) And (pOperatorValue1 <= 127)) Then
        begin
            Operator1HexString := RightStr(IntToHex(pOperatorValue1,8),2);
            ModifierHexSizeString := 'Hex2';
        end
    Else If((pOperatorValue1 >= -32768) And (pOperatorValue1 <= 332767)) Then
        begin
            Operator1HexString := RightStr(IntToHex(pOperatorValue1,8),4);
            ModifierHexSizeString := 'Hex4';
        end
    Else If((pOperatorValue1 >= -8388608) And (pOperatorValue1 <= 8388607)) Then
        begin
            Operator1HexString := RightStr(IntToHex(pOperatorValue1,8),6);
            ModifierHexSizeString := 'Hex6';
        end
    Else
        begin
            Operator1HexString := RightStr(IntToHex(pOperatorValue1,8),8);
            ModifierHexSizeString := 'Hex8';
        end;

    If((pOperatorValue2 >= -128) And (pOperatorValue2 <= $7F)) Then
        begin
            Operator2HexString := RightStr(IntToHex(pOperatorValue2,8),2);
            ModifierHexSizeString := 'Hex2';
        end
    Else If((pOperatorValue2 >= -32768) And (pOperatorValue2 <= 332767)) Then
        begin
            Operator2HexString := RightStr(IntToHex(pOperatorValue2,8),4);
            ModifierHexSizeString := 'Hex4';
        end
    Else If((pOperatorValue2 >= -8388608) And (pOperatorValue2 <= 8388607)) Then
        begin
            Operator2HexString := RightStr(IntToHex(pOperatorValue2,8),6);
            ModifierHexSizeString := 'Hex6';
        end
    Else
        begin
            Operator2HexString := RightStr(IntToHex(pOperatorValue2,8),8);
            ModifierHexSizeString := 'Hex8';
        end;

    If((AssignmentValue >= -128) And (AssignmentValue <= $7F)) Then
        begin
            AssignmentHexString := RightStr(IntToHex(AssignmentValue,8),2);
            ModifierHexSizeString := 'Hex2';
        end
    Else If((AssignmentValue >= -32768) And (AssignmentValue <= 332767)) Then
        begin
            AssignmentHexString := RightStr(IntToHex(AssignmentValue,8),4);
            ModifierHexSizeString := 'Hex4';
        end
    Else If((AssignmentValue >= -8388608) And (AssignmentValue <= 8388607)) Then
        begin
            AssignmentHexString := RightStr(IntToHex(AssignmentValue,8),6);
            ModifierHexSizeString := 'Hex6';
        end
    Else
        begin
            AssignmentHexString := RightStr(IntToHex(AssignmentValue,8),8);
            ModifierHexSizeString := 'Hex8';
        end;

    PrintCode('    HRSOut "' + IntToStr(pOperatorValue1) +
              '($' + Operator1HexString +
              ') ' + ExpressionType +
              ' ' + IntToStr(pOperatorValue2) +
              '($' + Operator2HexString +
              ') Should be $' + AssignmentHexString +
              ': Is $",' + ModifierHexSizeString +
              ' ' + Global_AssignmentName +
              ',13');
    PrintCode('''');
    PrintCode('''-----------------');
    PrintCode('''');
end;
//-----------------------------------------------------------------------------------------
// Get the assignement and operator variable types from what is in the edit boxes
//
procedure TForm1.GetOperatorTypes();
begin
//
// Operator 1
//
    If(Operator1TypeEditBox.Text = 'byte') Then
        begin
            Global_OperatorType1 := cType_Byte;
            Global_OperatorName1 := 'Bytein1';
        end
    Else If(Operator1TypeEditBox.Text = 'word') Then
        begin
            Global_OperatorType1 := cType_Word;
            Global_OperatorName1 := 'Wordin1';
        end
    Else If(Operator1TypeEditBox.Text = 'dword') Then
        begin
            Global_OperatorType1 := cType_Dword;
            Global_OperatorName1 := 'Dwordin1';
        end
    Else If(Operator1TypeEditBox.Text = 'sbyte') Then
        begin
            Global_OperatorType1 := cType_SByte;
            Global_OperatorName1 := 'sBytein1';
        end
    Else If(Operator1TypeEditBox.Text = 'sword') Then
        begin
            Global_OperatorType1 := cType_SWord;
            Global_OperatorName1 := 'sWordin1';
        end
    Else If(Operator1TypeEditBox.Text = 'sdword') Then
        begin
            Global_OperatorType1 := cType_SDword;
            Global_OperatorName1 := 'sDwordin1';
        end
    Else If(Operator1TypeEditBox.Text = 'float') Then
        begin
            Global_OperatorType1 := cType_Float;
            Global_OperatorName1 := 'Floatin1';
        end
    Else If(Operator1TypeEditBox.Text = 'constant') Then
        begin
            Global_OperatorType1 := cType_Constant;
        end
    Else If(Operator1TypeEditBox.Text = 'signed constant') Then
        begin
            Global_OperatorType1 := cType_SignedConstant;
        end;

//
// Operator 2
//
    If(Operator2TypeEditBox.Text = 'byte') Then
        begin
            Global_OperatorType2 := cType_Byte;
            Global_OperatorName2 := 'Bytein2';
        end
    Else If(Operator2TypeEditBox.Text = 'word') Then
        begin
            Global_OperatorType2 := cType_Word;
            Global_OperatorName2 := 'Wordin2';
        end
    Else If(Operator2TypeEditBox.Text = 'dword') Then
        begin
            Global_OperatorType2 := cType_Dword;
            Global_OperatorName2 := 'Dwordin2';
        end
    Else If(Operator2TypeEditBox.Text = 'sbyte') Then
        begin
            Global_OperatorType2 := cType_SByte;
            Global_OperatorName2 := 'sBytein2';
        end
    Else If(Operator2TypeEditBox.Text = 'sword') Then
        begin
            Global_OperatorType2 := cType_SWord;
            Global_OperatorName2 := 'sWordin2';
        end
    Else If(Operator2TypeEditBox.Text = 'sdword') Then
        begin
            Global_OperatorType2 := cType_SDword;
            Global_OperatorName2 := 'sDwordin2';
        end
    Else If(Operator2TypeEditBox.Text = 'float') Then
        begin
            Global_OperatorType2 := cType_Float;
            Global_OperatorName2 := 'Floatin2';
        end
    Else If(Operator2TypeEditBox.Text = 'constant') Then
        begin
            Global_OperatorType2 := cType_Constant;
        end
    Else If(Operator2TypeEditBox.Text = 'signed constant') Then
        begin
            Global_OperatorType2 := cType_SignedConstant;
        end;
//
// Assignment 2
//
    If(AssignmentTypeEditBox.Text = 'byte') Then
        begin
            Global_AssignmentType := cType_Byte;
            Global_AssignmentName := 'Byteout';
        end
    Else If(AssignmentTypeEditBox.Text = 'word') Then
        begin
            Global_AssignmentType := cType_Word;
            Global_AssignmentName := 'Wordout';
        end
    Else If(AssignmentTypeEditBox.Text = 'dword') Then
        begin
            Global_AssignmentType := cType_Dword;
            Global_AssignmentName := 'Dwordout';
        end
    Else If(AssignmentTypeEditBox.Text = 'sbyte') Then
        begin
            Global_AssignmentType := cType_SByte;
            Global_AssignmentName := 'sByteout';
        end
    Else If(AssignmentTypeEditBox.Text = 'sword') Then
        begin
            Global_AssignmentType := cType_SWord;
            Global_AssignmentName := 'sWordout';
        end
    Else If(AssignmentTypeEditBox.Text = 'sdword') Then
        begin
            Global_AssignmentType := cType_SDword;
            Global_AssignmentName := 'sDwordout';
        end
    Else If(AssignmentTypeEditBox.Text = 'float') Then
        begin
            Global_AssignmentType := cType_Float;
            Global_AssignmentName := 'Floatout';
        end;

    PrintMessage(AssignmentTypeEditBox.Text + ' = ' + Operator1TypeEditBox.Text + ' ' + ExpressionType + ' ' + Operator2TypeEditBox.Text);
end;
//-----------------------------------------------------------------------------------------
// Place the Dim statements into the BASIC program
//
procedure TForm1.PlaceVariableDeclarations(pOperatorType1: Int64; pOperatorType2: Int64);
Var
    OperatorTypeString1: String;
    OperatorTypeString2: String;
    AssignmentTypeString: String;
    DeviceCore: Integer;
begin
//
// Operator 1
//
    If(pOperatorType1 = cType_Byte) Then
        OperatorTypeString1 := 'Byte'
    Else If(pOperatorType1 = cType_Word) Then
        OperatorTypeString1 := 'Word'
    Else If(pOperatorType1 = cType_Dword) Then
        OperatorTypeString1 := 'Dword'
    Else If(pOperatorType1 = cType_SByte) Then
        OperatorTypeString1 := 'SByte'
    Else If(pOperatorType1 = cType_SWord) Then
        OperatorTypeString1 := 'SWord'
    Else If(pOperatorType1 = cType_SDword) Then
        OperatorTypeString1 := 'SDword'
    Else If(pOperatorType1 = cType_Float) Then
        OperatorTypeString1 := 'Float';
//
// Operator 2
//
    If(pOperatorType2 = cType_Byte) Then
        OperatorTypeString2 := 'Byte'
    Else If(pOperatorType2 = cType_Word) Then
        OperatorTypeString2 := 'Word'
    Else If(pOperatorType2 = cType_Dword) Then
        OperatorTypeString2 := 'Dword'
    Else If(pOperatorType2 = cType_SByte) Then
        OperatorTypeString2 := 'SByte'
    Else If(pOperatorType2 = cType_SWord) Then
        OperatorTypeString2 := 'SWord'
    Else If(pOperatorType2 = cType_SDword) Then
        OperatorTypeString2 := 'SDword'
    Else If(pOperatorType2 = cType_Float) Then
        OperatorTypeString2 := 'Float';
//
// Assignment
//
    If(Global_AssignmentType = cType_Byte) Then
        AssignmentTypeString := 'Byte'
    Else If(Global_AssignmentType = cType_Word) Then
        AssignmentTypeString := 'Word'
    Else If(Global_AssignmentType = cType_Dword) Then
        AssignmentTypeString := 'Dword'
    Else If(Global_AssignmentType = cType_SByte) Then
        AssignmentTypeString := 'SByte'
    Else If(Global_AssignmentType = cType_SWord) Then
        AssignmentTypeString := 'SWord'
    Else If(Global_AssignmentType = cType_SDword) Then
        AssignmentTypeString := 'SDword'
    Else If(Global_AssignmentType = cType_Float) Then
        AssignmentTypeString := 'Float';
//
// Create the code at the top of the program for a particular compiler and device
//
    If(Amicus18RadioButton.Checked = True) Then                         // Amicus18?
        begin
            DeviceCore := 18;                                           // 18F device
            PrintCode(''' Amicus18 Expression test');
            PrintCode('''');
        end
    Else If(ProtonRadioButton.Checked = True) Then
        begin
            //
            // Choose the device type
            //
            If(Core14RadioButton.Checked = True) Then                   // Standard 14-bit core device?
                begin
                    DeviceCore := 14;                                   // 16F device
                    PrintCode(''' Proton Expression test for standard 14-bit core devices');
                    PrintCode('''');
                    PrintCode('    Declare Reminders = Off');
                    PrintCode('    Device = 16F877');
                    PrintCode('    Declare Xtal = 4');
                end
            Else If(Core14eRadioButton.Checked = True) Then             // Enhanced 14-bit core device?
                begin
                    DeviceCore := 15;                                   // Enhanced 16F device
                    PrintCode(''' Proton Expression Test for enhanced 14-bit core devices');
                    PrintCode('''');
                    PrintCode('    Declare Reminders = Off');
                    PrintCode('    Device = 16F1939');
                    PrintCode('    Declare Xtal = 4');
                    PrintCode('''');
                    PrintCode('    Declare Optimiser_Level = 1');
                    PrintCode('    Declare Dead_Code_Remove = On');
                end
            Else If(Core16RadioButton.Checked = True) Then              // 18F device?
                begin
                    DeviceCore := 18;                                   // 18F device
                    PrintCode(''' Proton Expression test for 18F devices');
                    PrintCode('''');
                    PrintCode('    Declare Reminders = Off');
                    PrintCode('    Device = 18F452');
                    PrintCode('    Declare Xtal = 4');
                    PrintCode('''');
                    PrintCode('    Declare Optimiser_Level = 1');
                    PrintCode('    Declare Dead_Code_Remove = On');
                end;
            PrintCode('    Declare Hserial_Baud = 9600');
            PrintCode('    Declare Hserial_RCSTA = %10010000');
            PrintCode('    Declare Hserial_TXSTA = %00100100');
            PrintCode('    Declare Hserial_Clear = On');
            PrintCode('''');
        end;
//
// Place the assignment variable declaration
//
    PrintCode('    Dim ' + Global_AssignmentName + ' As ' + AssignmentTypeString);                      // Add the declaration for the assignment variable type
//
// Place the operator 1 variable declaration
//
    If((pOperatorType1 <> cType_Constant) And (pOperatorType1 <> cType_SignedConstant)) Then            // Is the left hand variable actually a constant value?
        begin                                                                                           // No. So...
            If(DifferentBanks.Checked = True) Then                                                      // Do we require the variables in different RAM banks?
                begin                                                                                   // Yes. So...
                    If(DeviceCore = 14) Then
                        PrintCode('    Dim ' + Global_OperatorName1 + ' As ' + OperatorTypeString1 + ' At $A0')    // Add the declaration for the operator 1 variable type
                    Else If(DeviceCore = 15) Then
                        PrintCode('    Dim ' + Global_OperatorName1 + ' As ' + OperatorTypeString1 + ' At $A0')    // Add the declaration for the operator 1 variable type
                    Else If(DeviceCore = 18) Then
                        PrintCode('    Dim ' + Global_OperatorName1 + ' As ' + OperatorTypeString1 + ' At $0100')  // Add the declaration for the operator 1 variable type
                    Else
                        PrintCode('    Dim ' + Global_OperatorName1 + ' As ' + OperatorTypeString1);    // Add the declaration for the operator 1 variable type
                end
            Else
                PrintCode('    Dim ' + Global_OperatorName1 + ' As ' + OperatorTypeString1);            // Add the declaration for the operator 1 variable type
        end;
//
// Place the operator 2 variable declaration
//
    If((pOperatorType2 <> cType_Constant) And (pOperatorType2 <> cType_SignedConstant))Then             // Is the right hand variable actually a constant value?
        begin
            If(DifferentBanks.Checked = True) Then                                                      // Do we require the variables in different RAM banks?
                begin                                                                                   // Yes. So...
                    If(DeviceCore = 14) Then
                        PrintCode('    Dim ' + Global_OperatorName2 + ' As ' + OperatorTypeString2 + ' At $0110')  // Add the declaration for the operator 2 variable type
                    Else If(DeviceCore = 15) Then
                        PrintCode('    Dim ' + Global_OperatorName2 + ' As ' + OperatorTypeString2 + ' At $0120')  // Add the declaration for the operator 2 variable type
                    Else If(DeviceCore = 18) Then
                        PrintCode('    Dim ' + Global_OperatorName2 + ' As ' + OperatorTypeString2 + ' At $0200')  // Add the declaration for the operator 2 variable type
                    Else
                        PrintCode('    Dim ' + Global_OperatorName2 + ' As ' + OperatorTypeString2);    // Add the declaration for the operator 2 variable type
                end
            Else
                PrintCode('    Dim ' + Global_OperatorName2 + ' As ' + OperatorTypeString2);            // Add the declaration for the operator 2 variable type
        end;

    PrintCode('''');
    PrintCode('''-----------------');
    PrintCode('''');
end;
//-----------------------------------------------------------------------------------------
procedure TForm1.PrintCode(pText: String);
begin
    Memo1.Lines.Add(pText);
    Application.ProcessMessages();
end;
//-----------------------------------------------------------------------------------------
procedure TForm1.PrintMessage(pText: String);
begin
    Memo2.Lines.Add(pText);
    Application.ProcessMessages();
end;

//-----------------------------------------------------------------------------------------
// Compiler Group Box - Amicus18 chosen event
//
procedure TForm1.Amicus18RadioButtonClick(Sender: TObject);
begin
//
// Clear both Memo windows
//
    Memo1.Lines.BeginUpdate();
    Memo1.Clear();
    Memo1.Lines.EndUpdate();

    Memo2.Lines.BeginUpdate();
    Memo2.Clear();
    Memo2.Lines.EndUpdate();

    DeviceGroupBox.Enabled := False;
    Core14RadioButton.Enabled := False;
    Core14eRadioButton.Enabled := False;
    Core16RadioButton.Enabled := False;
end;
//-----------------------------------------------------------------------------------------
// Compiler Group Box - Proton chosen event
//
procedure TForm1.ProtonRadioButtonClick(Sender: TObject);
begin
//
// Clear both Memo windows
//
    Memo1.Lines.BeginUpdate();
    Memo1.Clear();
    Memo1.Lines.EndUpdate();

    Memo2.Lines.BeginUpdate();
    Memo2.Clear();
    Memo2.Lines.EndUpdate();

    DeviceGroupBox.Enabled := True;
    Core14RadioButton.Enabled := True;
    Core14eRadioButton.Enabled := True;
    Core16RadioButton.Enabled := True;
//
// Disable unsupported devices and activate supported devices within the Device Group box
//
    Core14RadioButton.Enabled := True;
    Core14eRadioButton.Enabled := True;
    Core16RadioButton.Enabled := True;
end;
//-----------------------------------------------------------------------------------------
procedure TForm1.Core14RadioButtonClick(Sender: TObject);
begin
//
// Clear both Memo windows
//
    Memo1.Lines.BeginUpdate();
    Memo1.Clear();
    Memo1.Lines.EndUpdate();

    Memo2.Lines.BeginUpdate();
    Memo2.Clear();
    Memo2.Lines.EndUpdate();

end;
//-----------------------------------------------------------------------------------------
procedure TForm1.Core14eRadioButtonClick(Sender: TObject);
begin
//
// Clear both Memo windows
//
    Memo1.Lines.BeginUpdate();
    Memo1.Clear();
    Memo1.Lines.EndUpdate();

    Memo2.Lines.BeginUpdate();
    Memo2.Clear();
    Memo2.Lines.EndUpdate();

end;
//-----------------------------------------------------------------------------------------
procedure TForm1.Core16RadioButtonClick(Sender: TObject);
begin
//
// Clear both Memo windows
//
    Memo1.Lines.BeginUpdate();
    Memo1.Clear();
    Memo1.Lines.EndUpdate();

    Memo2.Lines.BeginUpdate();
    Memo2.Clear();
    Memo2.Lines.EndUpdate();

end;

end.
